/*
  ******************************************************************************
  * @file    apt32f172_gpio.c
  * @author  APT AE Team
  * @version V1.13
  * @date    2019/08/01
  ******************************************************************************
  *THIS SOFTWARE WHICH IS FOR ILLUSTRATIVE PURPOSES ONLY WHICH PROVIDES 
  *CUSTOMER WITH CODING INFORMATION REGARDING THEIR PRODUCTS.
  *APT CHIP SHALL NOT BE HELD RESPONSIBILITY ADN LIABILITY FOR ANY DIRECT, 
  *INDIRECT DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF 
  *SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION 
  *CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.AND APT CHIP RESERVES 
  *THE RIGHT TO MAKE CHANGES IN THE SOFTWARE WITHOUT NOTIFICATION
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/ 
#include "apt32f172.h"
#include "apt32f172_gpio.h"
/* defines -------------------------------------------------------------------*/

/* externs--------------------------------------------------------------------*/

/*************************************************************/
//IO RESET CLEAR ALL REGISTER
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/  
void GPIO_DeInit(void)
{
    GPIOA0->CONLR = GPIO_RESET_VALUE;                     
    GPIOA0->CONHR = GPIO_RESET_VALUE;
	GPIOA1->CONLR = GPIO_RESET_VALUE;                     
    GPIOA1->CONHR = GPIO_RESET_VALUE;
    GPIOB0->CONLR = GPIO_RESET_VALUE;                     
    GPIOB0->CONHR = GPIO_RESET_VALUE;
	GPIOC0->CONLR = GPIO_RESET_VALUE;                     
    GPIOC0->CONHR = GPIO_RESET_VALUE;
	GPIOD0->CONLR = GPIO_RESET_VALUE;                     
    GPIOD0->CONHR = GPIO_RESET_VALUE;
    GPIOA0->WODR  = GPIO_RESET_VALUE; 
	GPIOA1->WODR  = GPIO_RESET_VALUE; 
    GPIOB0->WODR  = GPIO_RESET_VALUE;
	GPIOC0->WODR  = GPIO_RESET_VALUE;
	GPIOD0->WODR  = GPIO_RESET_VALUE;
    GPIOA0->SODR  = GPIO_RESET_VALUE; 
	GPIOA1->SODR  = GPIO_RESET_VALUE; 
    GPIOB0->SODR  = GPIO_RESET_VALUE;
	GPIOC0->SODR  = GPIO_RESET_VALUE; 
	GPIOD0->SODR  = GPIO_RESET_VALUE; 
    GPIOA0->CODR  = GPIO_RESET_VALUE; 
	GPIOA1->CODR  = GPIO_RESET_VALUE; 
    GPIOB0->CODR  = GPIO_RESET_VALUE;
	GPIOC0->CODR  = GPIO_RESET_VALUE;
	GPIOD0->CODR  = GPIO_RESET_VALUE;
    GPIOA0->PUDR  = GPIO_RESET_VALUE; 
	GPIOA1->PUDR  = GPIO_RESET_VALUE; 
    GPIOB0->PUDR  = GPIO_RESET_VALUE;
	GPIOC0->PUDR  = GPIO_RESET_VALUE;
	GPIOD0->PUDR  = GPIO_RESET_VALUE;
    GPIOA0->DSCR  = GPIO_RESET_VALUE;
	GPIOA1->DSCR  = GPIO_RESET_VALUE;
    GPIOB0->DSCR  = GPIO_RESET_VALUE;
	GPIOC0->DSCR  = GPIO_RESET_VALUE;
	GPIOD0->DSCR  = GPIO_RESET_VALUE;
    GPIOA0->IECR  = GPIO_RESET_VALUE;
	GPIOA1->IECR  = GPIO_RESET_VALUE;
    GPIOB0->IECR  = GPIO_RESET_VALUE;
	GPIOC0->IECR  = GPIO_RESET_VALUE;
	GPIOD0->IECR  = GPIO_RESET_VALUE;
	GPIOA0->IEER  = GPIO_RESET_VALUE;
	GPIOA1->IEER  = GPIO_RESET_VALUE;
    GPIOB0->IEER  = GPIO_RESET_VALUE;
	GPIOC0->IEER  = GPIO_RESET_VALUE;
	GPIOD0->IEER  = GPIO_RESET_VALUE;
	GPIOA0->IEDR  = GPIO_RESET_VALUE;
	GPIOA1->IEDR  = GPIO_RESET_VALUE;
    GPIOB0->IEDR  = GPIO_RESET_VALUE;
	GPIOC0->IEDR  = GPIO_RESET_VALUE;
	GPIOD0->IEDR  = GPIO_RESET_VALUE;
    GPIOA0->ODSR  = GPIO_RESET_VALUE;
	GPIOA1->ODSR  = GPIO_RESET_VALUE;
    GPIOB0->ODSR  = GPIO_RESET_VALUE;
	GPIOC0->ODSR  = GPIO_RESET_VALUE;
	GPIOD0->ODSR  = GPIO_RESET_VALUE;
    GPIOA0->OMCR  = GPIO_RESET_VALUE;
	GPIOA1->OMCR  = GPIO_RESET_VALUE;
    GPIOB0->OMCR  = GPIO_RESET_VALUE;
	GPIOC0->OMCR  = GPIO_RESET_VALUE;
	GPIOD0->OMCR  = GPIO_RESET_VALUE;
    EXIGRP->IGRPL = GPIO_RESET_VALUE;
	EXIGRP->IGRPH = GPIO_RESET_VALUE;
}  
void GPIO_Debug_IO_03_04(void)
{
    GPIOA0->CONLR |= 0x00055000;
}
/*************************************************************/
//IO OUTPUT INPUT SET 1
//EntryParameter:GPIOx,GPIO_Pin(0~15),byte,Dir
//GPIOx:GPIOA0,GPIOB0,GPIOC0
//GPIO_Pin:PIN_0~15
//byte:Lowbyte(PIN_0~7),Highbyte(PIN_8~15)
//Dir:0:output 1:input
//ReturnValue:NONE
/*************************************************************/  
void GPIO_Init(CSP_GPIO_T *GPIOx,U8_T PinNum,GPIO_Dir_TypeDef Dir)
{
    uint32_t data_temp;
    uint8_t GPIO_Pin;
    if(PinNum<8)
    {
    switch (PinNum)
    {
        case 0:data_temp=0xfffffff0;GPIO_Pin=0;break;
        case 1:data_temp=0xffffff0f;GPIO_Pin=4;break;
        case 2:data_temp=0xfffff0ff;GPIO_Pin=8;break;
        case 3:data_temp=0xffff0fff;GPIO_Pin=12;break;
        case 4:data_temp=0xfff0ffff;GPIO_Pin=16;break;
        case 5:data_temp=0xff0fffff;GPIO_Pin=20;break;
        case 6:data_temp=0xf0ffffff;GPIO_Pin=24;break;
        case 7:data_temp=0x0fffffff;GPIO_Pin=28;break;
    }
        if (Dir)
        {
          (GPIOx)->CONLR =((GPIOx)->CONLR & data_temp) | 1<<GPIO_Pin;
        }
        else
        {
         (GPIOx)->CONLR = ((GPIOx)->CONLR & data_temp) | 2<<GPIO_Pin; 
        }
    }
    else if (PinNum<16)
    {
        switch (PinNum)
    {
        case 8:data_temp=0xfffffff0;GPIO_Pin=0;break;
        case 9:data_temp=0xffffff0f;GPIO_Pin=4;break;
        case 10:data_temp=0xfffff0ff;GPIO_Pin=8;break;
        case 11:data_temp=0xffff0fff;GPIO_Pin=12;break;
        case 12:data_temp=0xfff0ffff;GPIO_Pin=16;break;
        case 13:data_temp=0xff0fffff;GPIO_Pin=20;break;
        case 14:data_temp=0xf0ffffff;GPIO_Pin=24;break;
        case 15:data_temp=0x0fffffff;GPIO_Pin=28;break;
    } 
      if (Dir)
        {
        (GPIOx)->CONHR = ((GPIOx)->CONHR & data_temp) | 1<<GPIO_Pin;  
        }
        else
        {
         (GPIOx)->CONHR = ((GPIOx)->CONHR & data_temp) | 2<<GPIO_Pin;    
        }
    }
}
/*************************************************************/
//IO OUTPUT INPUT SET 2
//EntryParameter:GPIOx,byte,val
//GPIOx:GPIOA0,GPIOB0,GPIOC0
//byte:Lowbyte(PIN_0~7),Highbyte(PIN_8~15)
//val:0x0000000~0xFFFFFFFF
//val=0x11111111 all IO as input
//val=0x22222222 all IO as output
//ReturnValue:NONE
/*************************************************************/  
void GPIO_Init2(CSP_GPIO_T *GPIOx,GPIO_byte_TypeDef byte,uint32_t val)
{
    if (byte==0)
    {
        (GPIOx)->CONLR=val;
    }
    else if(byte==1)
    {
        (GPIOx)->CONHR=val;
    }
}
/*************************************************************/
//IO OUTPUT INPUT SET
//EntryParameter:IO_MODE,GPIOx,val
//GPIOx:GPIOA0,GPIOB0,GPIOC0
//IO_MODE:PUDR(IO PULL HIGH/LOW)
//IO_MODE:DSCR(IO DRIVE STRENGHT)
//IO_MODE:OMCR(IO OPEN DRAIN)
//IO_MODE:IECR(IO INT ENABLE)
//IO_MODE:IGRP(IO INT GROUP)
//ReturnValue:NONE
/*************************************************************/  
void GPIO_MODE_Init(CSP_GPIO_T *GPIOx,GPIO_Mode_TypeDef IO_MODE,uint32_t val)
{
        switch (IO_MODE)
        {
            case 0:(GPIOx)->PUDR  = val;break;               
            case 1:(GPIOx)->DSCR  = val;break;
            case 2:(GPIOx)->OMCR  = val;break;
            case 3:(GPIOx)->IECR  = val;break;
			case 4:(GPIOx)->IEER  = val;break;
			case 5:(GPIOx)->IEDR  = val;break;
            case 6:EXIGRP->IGRPL  = val;break;
			case 7:EXIGRP->IGRPH  = val;break;
        }
}
/*************************************************************/
//Write GPIO pull high/low
//EntryParameter:GPIOx,uint8_t bit
//GPIOx:GPIOA0,GPIOB0,GPIOC0
//bit:0~15
//ReturnValue:VALUE
/*************************************************************/
void GPIO_PullHigh_Init(CSP_GPIO_T *GPIOx,U8_T bit)
{
	(GPIOx)->PUDR  = (((GPIOx)->PUDR) & ~(0x03<<(bit*2))) | (0x01<<(bit*2));
}
void GPIO_PullLow_Init(CSP_GPIO_T *GPIOx,U8_T bit)
{
	(GPIOx)->PUDR  = (((GPIOx)->PUDR) & ~(0x03<<(bit*2))) | (0x02<<(bit*2));
}
void GPIO_PullHighLow_DIS(CSP_GPIO_T *GPIOx,U8_T bit)
{
	(GPIOx)->PUDR  = ((GPIOx)->PUDR) & ~(0x03<<(bit*2));
}
/*************************************************************/
//Write GPIO open drain init
//EntryParameter:GPIOx,uint8_t bit
//GPIOx:GPIOA0,GPIOB0,GPIOC0
//bit:0~15
//ReturnValue:VALUE
/*************************************************************/
void GPIO_OpenDrain_EN(CSP_GPIO_T *GPIOx,U8_T bit)
{
	(GPIOx)->OMCR  = ((GPIOx)->OMCR) | (0x01<<bit);
}
void GPIO_OpenDrain_DIS(CSP_GPIO_T *GPIOx,U8_T bit)
{
	(GPIOx)->OMCR  = ((GPIOx)->OMCR) & ~(0x01<<bit);
}
/*************************************************************/
//Write GPIO Drive Strength init
//EntryParameter:GPIOx,uint8_t bit
//GPIOx:GPIOA0,GPIOB0,GPIOC0
//bit:0~15
//ReturnValue:VALUE
/*************************************************************/
void GPIO_DriveStrength_EN(CSP_GPIO_T *GPIOx,U8_T bit)
{
	(GPIOx)->DSCR  = ((GPIOx)->DSCR) | (0x03<<(bit*2));
}
void GPIO_DriveStrength_DIS(CSP_GPIO_T *GPIOx,U8_T bit)
{
	(GPIOx)->DSCR  = ((GPIOx)->DSCR) & ~(0x03<<(bit*2));
}
/*************************************************************/
//IO OUTPUT INPUT SET
//EntryParameter:
//IO_MODE:IGRP(IO INT GROUP)
//ReturnValue:NONE
/*************************************************************/  
void GPIO_IntGroup_Set(GPIO_Group_TypeDef IO_MODE)
{
        switch (IO_MODE)
        {
            case 0:EXIGRP->IGRPL  = 0X00000000;EXIGRP->IGRPH  = 0X00000000;break;               
            case 1:EXIGRP->IGRPL  = 0X11111111;EXIGRP->IGRPH  = 0X11111111;break;
            case 2:EXIGRP->IGRPL  = 0X22222222;EXIGRP->IGRPH  = 0X22222222;break;
            case 3:EXIGRP->IGRPL  = 0X33333333;EXIGRP->IGRPH  = 0X33333333;break;
			case 4:EXIGRP->IGRPL  = 0X44444444;EXIGRP->IGRPH  = 0X44444444;break;
        }
}
/*************************************************************/
//IO  EXI GROUP SET 
//EntryParameter:GPIOx,uint8_t bit
//GPIOx:GPIOA0,GPIOA1,GPIOB0,GPIOC0,GPIOD0
//bit:0~15
//ReturnValue:NONE
/*************************************************************/  
void GPIO_IntGroup_Set_1(CSP_GPIO_T *GPIOx,U32_T bit)
{
	U8_T Intbank =0;
	U8_T IntGroup = bit;
	U8_T maskshift;
	U32_T rwmask;
	switch((U32_T)GPIOx){
		case APB_GPIOA0Base:
			Intbank = 0;
		break;
		case APB_GPIOA1Base:
			Intbank = 1;
		break;
		case APB_GPIOB0Base:
			Intbank = 2;
		break;
		case APB_GPIOC0Base:
			Intbank = 3;
		break;
		case APB_GPIOD0Base:
			Intbank = 4;
		break;
		default:
		break;
	}		
	if(bit < 8){
		maskshift = IntGroup<<2 ;
		rwmask = ~(0xF << maskshift);
		EXIGRP ->IGRPL = ((EXIGRP ->IGRPL) & rwmask) | (Intbank << maskshift);
		
	}
	else{
		maskshift = (IntGroup-8)<<2 ;
		rwmask = ~(0xF << maskshift);
		EXIGRP ->IGRPH = ((EXIGRP ->IGRPH) & rwmask) | (Intbank << maskshift);
	}		
}

/*************************************************************/
//IO EXI SET 
//EntryParameter:EXI_IO(EXI0~EXI13)
//ReturnValue:NONE
/*************************************************************/  
void GPIOA0_EXI_Init(GPIO_EXI_TypeDef EXI_IO)
{
    switch (EXI_IO)
    {
        case 0:GPIOA0->CONLR = (GPIOA0->CONLR&0XFFFFFFF0) | 0X00000001;break;
        case 1:GPIOA0->CONLR = (GPIOA0->CONLR&0XFFFFFF0F) | 0X00000010;break;
        case 2:GPIOA0->CONLR = (GPIOA0->CONLR&0XFFFFF0FF) | 0X00000100;break;
        case 3:GPIOA0->CONLR = (GPIOA0->CONLR&0XFFFF0FFF) | 0X00001000;break;
        case 4:GPIOA0->CONLR = (GPIOA0->CONLR&0XFFF0FFFF) | 0X00010000;break;
        case 5:GPIOA0->CONLR = (GPIOA0->CONLR&0XFF0FFFFF) | 0X00100000;break;
        case 6:GPIOA0->CONLR = (GPIOA0->CONLR&0XF0FFFFFF) | 0X01000000;break;
        case 7:GPIOA0->CONLR = (GPIOA0->CONLR&0X0FFFFFFF) | 0X10000000;break;
        case 8:GPIOA0->CONHR = (GPIOA0->CONHR&0XFFFFFFF0) | 0X00000001;break;
        case 9:GPIOA0->CONHR = (GPIOA0->CONHR&0XFFFFFF0F) | 0X00000010;break;
        case 10:GPIOA0->CONHR = (GPIOA0->CONHR&0XFFFFF0FF) | 0X00000100;break;
        case 11:GPIOA0->CONHR = (GPIOA0->CONHR&0XFFFF0FFF) | 0X00001000;break;
        case 12:GPIOA0->CONHR = (GPIOA0->CONHR&0XFFF0FFFF) | 0X00010000;break;
        case 13:GPIOA0->CONHR = (GPIOA0->CONHR&0XFF0FFFFF) | 0X00100000;break;
		case 14:GPIOA0->CONHR = (GPIOA0->CONHR&0XF0FFFFFF) | 0X00100000;break;
		case 15:GPIOA0->CONHR = (GPIOA0->CONHR&0XFFFFFFFF) | 0X00100000;break;
    }
}
void GPIOA1_EXI_Init(GPIO_EXI_TypeDef EXI_IO)
{
    switch (EXI_IO)
    {
        case 0:GPIOA1->CONLR = (GPIOA0->CONLR&0XFFFFFFF0) | 0X00000001;break;
        case 1:GPIOA1->CONLR = (GPIOA0->CONLR&0XFFFFFF0F) | 0X00000010;break;
        case 2:GPIOA1->CONLR = (GPIOA0->CONLR&0XFFFFF0FF) | 0X00000100;break;
        case 3:GPIOA1->CONLR = (GPIOA0->CONLR&0XFFFF0FFF) | 0X00001000;break;
        case 4:GPIOA1->CONLR = (GPIOA0->CONLR&0XFFF0FFFF) | 0X00010000;break;
        case 5:GPIOA1->CONLR = (GPIOA0->CONLR&0XFF0FFFFF) | 0X00100000;break;
		default:break;
    }
}
void GPIOB0_EXI_Init(GPIO_EXI_TypeDef EXI_IO)
{
    switch (EXI_IO)
    {
        case 0:GPIOB0->CONLR = (GPIOB0->CONLR&0XFFFFFFF0) | 0X00000001;break;
        case 1:GPIOB0->CONLR = (GPIOB0->CONLR&0XFFFFFF0F) | 0X00000010;break;
        default:break;
    }
}
void GPIOC0_EXI_Init(GPIO_EXI_TypeDef EXI_IO)
{
    switch (EXI_IO)
    {
        case 0:GPIOC0->CONLR = (GPIOC0->CONLR&0XFFFFFFF0) | 0X00000001;break;
        case 1:GPIOC0->CONLR = (GPIOC0->CONLR&0XFFFFFF0F) | 0X00000010;break;
        case 2:GPIOC0->CONLR = (GPIOC0->CONLR&0XFFFFF0FF) | 0X00000100;break;
        case 3:GPIOC0->CONLR = (GPIOC0->CONLR&0XFFFF0FFF) | 0X00001000;break;
        default:break;
    }
}
void GPIO_EXI_EN(CSP_GPIO_T *GPIOx,GPIO_EXI_TypeDef EXI_IO)
{
    (GPIOx)->IECR  |= 1<<EXI_IO;
}
void GPIO_EXI_ENSet(CSP_GPIO_T *GPIOx,GPIO_EXI_TypeDef EXI_IO)
{
    (GPIOx)->IEER  |= 1<<EXI_IO;
}
void GPIO_EXI_DISSet(CSP_GPIO_T *GPIOx,GPIO_EXI_TypeDef EXI_IO)
{
    (GPIOx)->IEDR  |= 1<<EXI_IO;
}
/*************************************************************/
//Write GPIO 
//EntryParameter:GPIOx,uint8_t bit
//GPIOx:GPIOA0,GPIOB0,GPIOC0
//bit:0~15
//ReturnValue:VALUE
/*************************************************************/
void GPIO_Write_High(CSP_GPIO_T *GPIOx,U8_T bit)
{
        (GPIOx)->SODR = (1ul<<bit);
}
void GPIO_Write_Low(CSP_GPIO_T *GPIOx,U8_T bit)
{
        (GPIOx)->CODR = (1ul<<bit);
}
/*************************************************************/
//Write GPIO 
//EntryParameter:GPIOx,uint8_t bitposi bitval
//GPIOx:GPIOA0,GPIOB0,GPIOC0
//bitposi:0~15 bitval:0~1 0=low 1=high
//ReturnValue:VALUE
/*************************************************************/
void GPIO_Set_Value(CSP_GPIO_T *GPIOx,U8_T bitposi,U8_T bitval)
{
    if (bitval==1)
    {
        (GPIOx)->SODR = (1ul<<bitposi);
    }
    else if ((bitval==0))
    {
        (GPIOx)->CODR = (1ul<<bitposi);
    }
}
/*************************************************************/
//Write GPIO reverse
//EntryParameter:GPIOx,uint8_t bit
//GPIOx:GPIOA0,GPIOB0,GPIOC0
//bit:0~15
//ReturnValue:VALUE
/*************************************************************/
void GPIO_Reverse(CSP_GPIO_T *GPIOx,U8_T bit)
{
     uint32_t dat = 0;
     dat=((GPIOx)->ODSR>>bit)&1ul;
     {
       if (dat==1)  
       {
           (GPIOx)->CODR = (1ul<<bit);
           return;
       }
       if (dat==0)
       {
           (GPIOx)->SODR = (1ul<<bit);
           return;
       }
     }
}
/*************************************************************/
//READ PA IO STATUS
//EntryParameter:GPIOx,uint8_t bit
//GPIOx:GPIOA0,GPIOB0,GPIOC0
//bit:0~15
//ReturnValue:VALUE
/*************************************************************/
uint8_t GPIO_Read_Status(CSP_GPIO_T *GPIOx,U8_T bit)
{
    uint8_t value = 0;
    uint32_t dat = 0;
    dat=((GPIOx)->PSDR)&(1<<bit);
    if (dat == (1<<bit))								
	{
	    value = 1;
	} 
    return value;
}
/*************************************************************/
//READ PA OUTPUT STATUS
//EntryParameter:GPIOx,uint8_t bit
//GPIOx:GPIOA0,GPIOB0,GPIOC0
//bit:0~15
//ReturnValue:VALUE
/*************************************************************/
uint8_t GPIO_Read_Output(CSP_GPIO_T *GPIOx,U8_T bit)
{
    uint8_t value = 0;
    uint32_t dat = 0;
    dat=((GPIOx)->ODSR)&(1<<bit);
    if (dat == (1<<bit))								
	{
	    value = 1;
	} 
    return value;
}
/*************************************************************/
//set PA0.0 as reset pin
//EntryParameter:NONE
//ReturnValue:VALUE
/*************************************************************/
void GPIOA00_Set_ResetPin()
{
    GPIOA0->CONLR=(GPIOA0->CONLR & 0XFFFFFFF0)|0x00000006; 
}
/******************* (C) COPYRIGHT 2018 APT Chip *****END OF FILE****/
